<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityCartTemplate extends JPlugin
{
	function plgCommunityCartTemplate(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}


	function onProfileExtra( $user,  $params = null, $name )
	{
		if ($name != 'carttemplate') return;

		global $mainframe;
		$document = &JFactory::getDocument();
		$db 	  = &JFactory::getDBO();
		$sectionId = $this->params->get('section_id');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_commerce'.DS.'controllers'.DS.'config.php');
		
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_commerce'.DS.'models');
		$model = &JModel::getInstance('Carttemplate', 'CommerceModel');
		$model_order  = JModel::getInstance('Orders', 'CommerceModel');

		$sections = $this->getCommerceSections();
		if(!$sections) return;

		$out_text = '';
		$limit = $this->params->get('limit', 5);
		$product_limit = $this->params->get('product_limit', 10);
		foreach ($sections as $section)
		{

			$comm_params = ResHelper::getSectionParams($section->id);
			CommerceControllerConfig::initialyze($comm_params, $section->id);
			$rows = $model->getUserTemplateList($user->id, $section->id, $limit);
			if(!$rows) continue;

			$out_text .= '<h2>';
			if($this->params->get('section_link', 1))
			{
				$link = 'index.php?option=com_resource&view=list&category_id='.$section->id.'&Itemid='.$comm_params->get('category_itemid');
				$out_text .= JHTML::link(JRoute::_($link, false), $section->name, 'target="_blank"');
			}
			else
			$out_text .= $section->name;
			$out_text .= '</h2>';
			$itemid		= COMM_CARTTEMPLATE_ITEMID != '' ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt('Itemid');

			$link = 'index.php?option=com_commerce&view=carttemplate&section_id='.$section->id.'&Itemid='.$itemid;
			$out_text .= '<span>'.JHTML::link(JRoute::_($link, false), JText::_('All templates')).'</span>';
			$out_text .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			$link = 'index.php?option=com_commerce&view=carttemplate&user_id='.$user->id.'&section_id='.$section->id.'&Itemid='.$itemid;
			$out_text .= '<span>'.JHTML::link(JRoute::_($link, false), JText::_("All templates of this user")).'</span><br><br>';
			
			$out_text .= '<table border="0" width="100%" cellspacing="0" cellpadding="0">';
			$out_text .= '
			<thead>
			  <TR align="center">
			    <td class="sectiontableheader" width="1%">'.JText::_( '#' ).'</td>
			    <td class="sectiontableheader" class="title">'.JText::_('Template Name').'</td>
			    <td class="sectiontableheader" width="20%">'.JText::_('Description').'</td>
			    <td class="sectiontableheader" width="20%" nowrap="nowrap">'.JText::_('Created').'</td>
			  </TR>
			</thead>';
			$i = 1;
			$p = 0;
			foreach ($rows as $k => $item)
			{
				$products = unserialize($item->details);
				if(count($products))
				{
					$num = 1;
					foreach ($products as $row)
					{
							
						if($num > $product_limit)
						{
							$item->products[] = '... .';
							break;
						}
						$art = $model->getArticleInfo($row->article);
						$item->products[] = JHTML::link($row->link, $art->title, 'target="_blank" class="small"');
						$num ++;
					}
				}
				else
				$item->products = array();

				$ctime = new JDate($item->ctime);

				$out_text .= '<tr class="sectiontableentry'.($p + 1).'" valign="top">';

				$out_text .= '<td>'.$i.'</td>';
				$link = 'index.php?option=com_commerce&view=carttemplate&user_id='.$item->user_id.'&layout=details&id='.$item->id.'&section_id='.$section->id.'&Itemid='.$itemid;

				$out_text .= '<td>'.JHTML::link(JRoute::_($link, false), $item->name);
				if(count($item->products))
				$out_text .= '<br>'.JText::_('Products').': '.implode(', ', $item->products) ;
				$out_text .= '</td>';

				$out_text .= '<td>'.$item->description.'</td>';
				
				$out_text .= '<td nowrap><span class="createdate">'.$ctime->toFormat($comm_params->get('comm_date_format')).'</span></td>';

				$out_text .= '</tr>';
				$i ++;
				$p = 1- $p;
			}
			$out_text .= '</table>';
		}
		$ret = new JSCommunityTab();
		$ret->name  = 'jc_carttemplate';
		$ret->title = JText::_("Cart templates");
		$ret->text  = $out_text;

		return $ret;

	}

	function onUserSlideMenu($user)
	{
		$Itemid = $this->params->get('item_itemid', JRequest::getInt('Itemid'));
		$menu->link = JRoute::_("index.php?option=com_commerce&view=carttemplate&section_id=".$this->params->get('section_id')."&user_id={$user->id}&Itemid={$Itemid}");
		$menu->icon="plugins/community/carttemplate_icon.png";
		$menu->alt = ucfirst($user->username).' '.JText::_("cart templates");
		return $menu;

	}

	function getCommerceSections()
	{
		$db	= & JFactory::getDBO();

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		$sql = "SELECT id, name FROM #__js_res_category WHERE parent = '0' AND published = '1' ORDER BY ordering, id";
		$db->setQuery($sql);
		$res = $db->loadObjectList();
		if($res)
		{
			foreach ($res as $k => $val)
			{
				$CP = ResHelper::getSectionParams($val->id);
				if(!$CP->get('comm_enabled'))
				unset($res[$k]);
			}
		}
		return $res;

	}


}
?>