<?php
/**
 * @Copyright 2006-2008 JoomSuite
 * @created 07.05.2009
 */
defined('_JEXEC') or die('Restricted Access');
class plgCommunityTwitter extends JPlugin
{
	function plgCommunityTwitter(&$subject, $config)
	{
		parent::__construct($subject, $config);
		//$this->params->set('template', 'default');
	}

	function onProfileExtra($user, $params='', $name)
	{
		global $mainframe;
		$db = &JFactory::getDBO();
		if ($name != 'twitter')
		{
			return;
		}
		$sql = "
		CREATE TABLE IF NOT EXISTS #__community_twitter (
		  \n `id` int(10) unsigned NOT NULL auto_increment,
		  \n `ref_id` int(10) unsigned NOT NULL COMMENT 'ID of the message in the twitter.com service',
		  \n `user_id` int(10) unsigned NOT NULL,
		  \n `message` text NOT NULL,
		  \n `reply_to` int(10) unsigned NOT NULL COMMENT 'ID of the user whom this message is sent to',
		  \n `published` tinyint(3) unsigned NOT NULL,
		  \n `ctime` datetime NOT NULL,
		  \n `params` text NOT NULL,
		  \n `user_to` int(10) unsigned NOT NULL,
		  \n PRIMARY KEY  (`id`),
		  \n KEY `published` (`published`),
		  \n KEY `user_id` (`user_id`)
		  \n ) ;";
		$db->setQuery($sql);
		$db->query();
		
		$currentUser = &JFactory::getUser();

		$avatar_width = $this->params->get('avatar_width', 64);
		$avatar_height = $this->params->get('avatar_height', 64);
		$tab = new JSCommunityTab();

		$document = &JFactory::getDocument();
		/*print "<pre>";
		print_r($params);
		print "</pre>";
		exit;*/
		require_once(JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'twitter'.DS.'helper.php');

		$document->addStyleSheet(JURI::root().'plugins/community/twitter/twitter.css');
		$document->addScript(JURI::root().'plugins/community/twitter/twitter.js');

		$uri = &JFactory::getURI();

		$html = '';
		$html .= '<form name="twitter-form" action="'.$uri->toString().'" method="post">';
		$sync = $params->get("twitter_sync", 0);
		if ($currentUser->get('id') == $user->get('id'))
		{
			ob_start();
			require_once(JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'twitter'.DS.'inputbox.php');
			$html .= ob_get_contents();
			ob_end_clean();
		}

		jimport('joomla.html.pagination');

		$result = JSTwitterHelper::getUserMessages($user->id, $params, $this->params);

		$limit		= $params->get('user_profile_limit', 5);
		$pagination = new JPagination( $result->total, JRequest::getInt('limitstart', 0) , $limit );

		$messages    = &$result->messages;
		$name_style = $this->params->get('name_style', 0);
		ob_start();
		require_once(JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'twitter'.DS.'layout.php');
		$html .= ob_get_contents();
		ob_end_clean();

		$html .= "<div style='text-align: center;'>".$pagination->getPagesLinks()."</div>";
		$html .='</form>';
		$tab->text = $html;
		$tab->title = JText::_("Twitter");
		$tab->description = JText::_("Twitter Tab description");
		$tab->name = "twitter_tab";
		/*print "<pre>";
		print_r($tab);
		print "</pre>";
		exit;*/
		return $tab;
	}

	function onCustomUserList($client, $limitstart, $limit)
	{
		if ($client != 'twitter'){return;}
		$postid = JRequest::getInt('postid', 0);
		//$user_id = JRequest::getInt('user_id', 0);
		// here we check if we have entering information for plugin to continue
		if ($postid < 1  ){return;}
		
		JRequest::setVar('customlist_tmpl', $this->params->get('template', 'default'));

		$avatar_width = $this->params->get('avatar_width', 64);
		$avatar_height = $this->params->get('avatar_height', 64);
		$document = &JFactory::getDocument();

		require_once(JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'twitter'.DS.'helper.php');

		$document->addStyleSheet(JURI::root().'plugins/community/twitter/twitter.css');
		$document->addScript(JURI::root().'plugins/community/twitter/twitter.js');

		$currentUser = &JFactory::getUser();
		$db = &JFactory::getDBO();

		$return = new StdClass();
		$return->users = array();
		$return->page_title = JText::_("Discussion");
		$return->description = "";
		$return->notice = 0;
		$return->total = 0;



		if ($postid)
		{
			$sql = "SELECT u.*, ct.user_id, ct.id AS tid, ct.ref_id, ct.message, ct.reply_to, ct.published, ct.ctime, ct.params, ct.user_to   FROM #__community_twitter AS ct"
			."\n INNER JOIN #__users AS u ON u.id = ct.user_id "
			."\n WHERE ct.id = {$postid}";

			$db->setQuery($sql);
			//echo $db->_sql;
			$parent = $db->loadObject();
			if (empty($parent->id) )
			{
				return;
			}
			$name = JSTwitterHelper::getUserNameStyled($parent, $this->params->get("name_style", 0));
			$descr = '<table cellpadding="2" width="100%">
					<tr valign="top">
						<td width="1" valign="top"><img src="index2.php?option=com_community&controller=profile&task=avatar&user_id='.$parent->id.'&width='.$avatar_width.'&height='.$avatar_height.'&no_ajax=1">
						<a href="'.JRoute::_("index.php?option=com_community&view=profile&user_id={$parent->id}&Itemid=".JRequest::getInt('Itemid')).'">'.JSTwitterHelper::getUserNameStyled($parent, $this->params->get('name_style', 0)).'</a></td>
						<td>
						'.JSTwitterHelper::getTwitterHTMLBlock($parent, $this->params->get('name_style', 0)).'
						</td>
					</tr>
				  </table>

				';
			$contents = "";

			if ($currentUser->get('id') > 0)
			{
				$sql = "SELECT id FROM #__plugins WHERE element = 'twitter' AND folder='community' ";
				$db->setQuery($sql);
				$plg_id = (int)$db->loadResult();
				$sql = "SELECT params FROM #__community_blocks WHERE user_id = {$currentUser->id} AND plugin_id = $plg_id ";
				$db->setQuery($sql);

				$plgParams= new JParameter($db->loadResult());
				$sync = $plgParams->get('twitter_sync', 0);
				ob_start();
				require_once(JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'twitter'.DS.'inputbox.php');
				$contents = ob_get_contents();
				ob_end_clean();
			}
			$return->description=$descr.$contents."<hr>";
			// getting the main record
			$sql = "SELECT * FROM #__community_twitter WHERE id = ".(int)$postid;
			$db->setQuery($sql);
			$mainRecord = $db->loadObject();
			$limitStr = "";

			if ($limit)
			{

				$limitStr = " LIMIT {$limit}";

			}
			if ($limitstart && $limit)
			{
				$limitStr = " LIMIT {$limitstart}, {$limit}";
			}
			//we need to get all posts related to this one and all twits
			$sql = "SELECT u.*, ct2.id AS tid, ct2.user_id, ct2.ref_id, ct2.message, ct2.reply_to, ct2.published, ct2.ctime, ct2.params, ct2.user_to   FROM #__community_twitter AS ct"
			."\n INNER JOIN #__community_twitter AS ct2 ON ct2.reply_to = ".(int)$postid
			."\n INNER JOIN #__users AS u ON u.id = ct2.user_id "
			."\n GROUP BY (ct2.id) ORDER BY ct2.ctime DESC ".$limitStr
			."";
			$db->setQuery($sql);
			$childRecords = $db->loadObjectList();
			$sql = "SELECT COUNT(DISTINCT(ct2.id))  FROM #__community_twitter AS ct"
			."\n INNER JOIN #__community_twitter AS ct2 ON ct2.reply_to = ".(int)$postid
			."\n INNER JOIN #__users AS u ON u.id = ct2.user_id "
			."\n ORDER BY ct2.ctime"
			."";
			$db->setQuery($sql);
			$return->total = $db->loadResult();

			for($i = 0; $i < count($childRecords); $i++)
			{
				$item = &$childRecords[$i];
				$item->custom_data = JSTwitterHelper::getTwitterHTMLBlock($item, $this->params->get('name_style', 0));

			}

			$return->users = $childRecords;
			return $return;
		}

	}
}
?>